//@author: vux
//@help: builds round rects in vertex shader
//@tags: color
//@credits: 

StructuredBuffer<float4x4> sbWorld : register(t0);
StructuredBuffer<float2> sbSubElementScale : register(t2);
StructuredBuffer<uint> sbSubElementIndex : register(t3);

cbuffer cbPerDraw : register(b0)
{
	float4x4 tVP : LAYERVIEWPROJECTION;
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
	int di : DRAWINDEX;
};

void VS(float4 objPos : POSITION, uint iv : SV_VertexID, out float4 screenPos : SV_Position)
{
	float4x4 w = sbWorld[di];


	screenPos = mul(objPos,mul(w,tVP));

}

float4 PS(float4 p : SV_Position): SV_Target
{
    float4 col = cAmb;
    return col;
}

technique11 Render
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS() ) );
	}
}





